/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.51 from the
 * contents of RawQuote.xs. Do not edit this file, edit RawQuote.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "lib/Syntax/Keyword/RawQuote.xs"
#define PERL_NO_GET_CONTEXT

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include <string.h>
#include <stdlib.h>

#define MY_PKG "Syntax::Keyword::RawQuote"
#define HINTK_KEYWORDS MY_PKG "/keywords"

static int enabled(pTHX_ const char *kw_ptr, STRLEN kw_len) {
  HV *hints;
  SV **psv;
  char *p, *pv;
  STRLEN pv_len;


  /* No hints in effect */
  if (!(hints = GvHV(PL_hintgv))) {
    return 0;
  }

  /* No keywords in effect */
  if (!(psv = hv_fetchs(hints, HINTK_KEYWORDS, 0))) {
    return 0;
  }

  pv = SvPV(*psv, pv_len);

  /* Copied, with modifications, from mauke's Keyword::Simple.
   * Match ,keyword($|,) in pv. The Perl layer provides a , even
   * before the first value.
   */
  for (p = pv;
    (p = strchr(p + 1, *kw_ptr)) &&
    p <= pv + pv_len - kw_len;
  ) {
    if (
      (p[-1] == ',')
      && ((p + kw_len == pv + pv_len) || (p[kw_len] == ','))
      && (memcmp(kw_ptr, p, kw_len) == 0)
    ) {
      return 1;
    }
  }
  return 0;
}

/* Populate ender with the matching delimiter for delim (which is
 * a unichar) and return its length. As for quote-like operators,
 * [] {} <> and () are recognized as matching pairs, and other
 * characters match themselves.
 */
static STRLEN matching_delimiter(pTHX_ I32 delim, char *ender) {
  char *p;

  switch (delim) {
    case '[':
      ender[0] = ']';
      return 1;
    case '{':
      ender[0] = '}';
      return 1;
    case '<':
      ender[0] = '>';
      return 1;
    case '(':
      ender[0] = ')';
      return 1;
    default:
      p = uvchr_to_utf8(ender, delim);
      return p - ender;
  }
}

static const void *my_memmem(const void *haystack, size_t haystacklen,
    const void *needle, size_t needlelen) {
  const void *p;
  for (p = haystack;
    ((p = memchr(p, *((char *)needle), haystacklen - (p - haystack))) != NULL) &&
    p + needlelen <= haystack + haystacklen;
  ) {
    if (memcmp(p, needle, needlelen) == 0) {
      return p;
    }
  }
  return NULL;
}

/* The keyword has been recognized. What follows is the raw-quoted
 * string itself. Parse it (leaving the parser after the string) and return
 * an OP_CONST containing the string contents. Delimiters are handled the
 * same as quote-like operators, with the opening delimiter being the first
 * non-whitespace character after the keyword, and the closing delimiter being
 * the matching character if it's an ASCII bracket, or the same as the opening
 * delimiter otherwise. Unlike the built-in quote-likes, there is no backslashing.
 * The first occurrence of the closing delimiter ends the string.
 */
static OP* make_op(pTHX) {
  SV *str = newSVpvn("", 0);
  I32 delim;
  char ender[UTF8_MAXBYTES + 1];
  STRLEN ender_len;
  const char *end;

  /* Discard whitespace */
  lex_read_space(0);

  /* Get the opening delimiter as a unichar */
  delim = lex_read_unichar(0);
  /* And compute the matching close delimiter */
  ender_len = matching_delimiter(aTHX_ delim, ender);

  /* This is the equivalent of the UTF8 flag for linestr. Set it accordingly on the output. */
  if (lex_bufutf8()) {
    SvUTF8_on(str);
  }

  /* If we reach the end of linestr without finding the close delimiter... */
  while ((end = my_memmem(PL_parser->bufptr, PL_parser->bufend - PL_parser->bufptr, ender, ender_len)) == NULL) {
    /* Concatenate what we have before it goes away, */
    sv_catpvn(str, PL_parser->bufptr, PL_parser->bufend - PL_parser->bufptr);
    /* Tell the lexer that we consumed everything (rumor says that lex_next_chunk
     * doesn't always behave reliably otherwise),
     */
    lex_read_to(PL_parser->bufend);
    /* Read more input, */
    if (!lex_next_chunk(0)) {
      /* And complain if we got to EOF without finding the close delimiter */
      croak("Can't find string terminator %.*s anywhere before EOF", (int)ender_len, ender);
    }
  }
  /* 'end' now points to the beginning of the close delimiter. Copy
   * everything up to there into str
   */
  sv_catpvn(str, PL_parser->bufptr, end - PL_parser->bufptr);
  /* Consume the input plus the closing delimiter */
  lex_read_to(end + ender_len);
  /* And finally make the OP_CONST and return it. */
  return newSVOP(OP_CONST, 0, str);
}

static int (*next_keyword_plugin)(pTHX_ char *, STRLEN, OP **);

static int my_keyword_plugin(pTHX_ char *kw_ptr, STRLEN kw_len, OP **op_ptr) {
  if (enabled(aTHX_ kw_ptr, kw_len)) {
    *op_ptr = make_op(aTHX);
    return KEYWORD_PLUGIN_EXPR;
  } else {
    return next_keyword_plugin(aTHX_ kw_ptr, kw_len, op_ptr);
  }
}

#line 166 "temp/RawQuote.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 310 "temp/RawQuote.c"
#ifdef __cplusplus
extern "C" {
#endif
XS_EXTERNAL(boot_Syntax__Keyword__RawQuote); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Syntax__Keyword__RawQuote)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif


    /* Initialisation Section */

#line 160 "lib/Syntax/Keyword/RawQuote.xs"
{
  HV *const stash = gv_stashpvs(MY_PKG, GV_ADD);
  newCONSTSUB(stash, "HINTK_KEYWORDS", newSVpvs(HINTK_KEYWORDS));
  next_keyword_plugin = PL_keyword_plugin;
  PL_keyword_plugin = my_keyword_plugin;
}

#line 343 "temp/RawQuote.c"

    /* End of Initialisation Section */

#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

#ifdef __cplusplus
}
#endif
